#include "DIALOG.h"

/*********************************************************************
*
*       Externals
*
**********************************************************************
*/

/*********************************************************************
*
*       Types
*
**********************************************************************
*/

/*********************************************************************
*
*       Defines
*
**********************************************************************
*/
#define ANIM_PERIOD  400
#define WINDOW_SIZE  120
#define WINDOW_X_POS 140
#define WINDOW_Y_POS 10

/*********************************************************************
*
*       Static data
*
**********************************************************************
*/
static WM_HWIN _hWin2;

/*********************************************************************
*
*       Static code
*
**********************************************************************
*/
/*********************************************************************
*
*       _cbWin2
*/
static void _cbWin2(WM_MESSAGE * pMsg) {
  switch (pMsg->MsgId) {
  case WM_PAINT:
    //
    // Draw something.
    //
    GUI_SetBkColor(GUI_BLUE);
    GUI_Clear();
    GUI_SetFont(&GUI_Font16B_1);
    GUI_SetColor(GUI_WHITE);
    GUI_DispString("Window 2");
    break;
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       _cbWin
*/
static void _cbWin1(WM_MESSAGE * pMsg) {
  int Id;
  int NCode;
  WM_HWIN hButton;
  static int Hidden;

  switch (pMsg->MsgId) {
  case WM_CREATE:
    //
    // Create a button and set this window as the parent window.
    //
    hButton = BUTTON_CreateEx(10, 50, 80, 20, pMsg->hWin, WM_CF_SHOW, 0, GUI_ID_BUTTON0);
    BUTTON_SetText(hButton, "Show Win2");
    Hidden = 1;
    break;
  case WM_PAINT:
    //
    // Draw something.
    //
    GUI_SetBkColor(GUI_GREEN);
    GUI_Clear();
    GUI_SetFont(&GUI_Font16B_1);
    GUI_SetColor(GUI_WHITE);
    GUI_DispString("Window 1");
    break;
  case WM_NOTIFY_PARENT:
    //
    // React on WM_NOTIFY_PARENT messages that are sent to the parent of the widget (in this case button).
    //
    NCode = pMsg->Data.v;
    Id    = WM_GetId(pMsg->hWinSrc);
    switch(NCode) {
    case WM_NOTIFICATION_RELEASED: // When button click was released.
      switch(Id) {
      case GUI_ID_BUTTON0: // Check if it's the correct button.
        //
        // You can vary with the move in/out positions. When it's like this, where the given positions
        // are just the same as where the window is located, the window is only minimized/maximized.
        // But it's also possible to pick a coordinate on the screen or out of the visible area to move
        // the window to this point.
        //
        if(Hidden) {
          GUI_MEMDEV_MoveInWindow(_hWin2, WINDOW_X_POS, WINDOW_Y_POS, 0, ANIM_PERIOD);
        } else {
          GUI_MEMDEV_MoveOutWindow(_hWin2, WINDOW_X_POS, WINDOW_Y_POS, 0, ANIM_PERIOD);
        }
        //
        // Toggle hidden flag.
        //
        Hidden ^= 1;
        break;
      }
      break;
    }
    break;
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/
/*********************************************************************
*
*       MainTask
*/
void MainTask(void) {
  GUI_Init();
  //
  // Enable multi-buffering to avoid flickering during the animation.
  //
  WM_MULTIBUF_Enable(1);
  //
  // Create our 'main' window
  //
  WM_CreateWindow(10, 10, WINDOW_SIZE, WINDOW_SIZE, WM_CF_SHOW, _cbWin1, 0);
  //
  // Create window that will be shown.
  // The flag WM_CF_HIDE prevents the window from being drawn after it is created.
  // This flag will be cleared by the MoveIn/OutWindow functions.
  //
  _hWin2 = WM_CreateWindow(WINDOW_X_POS, WINDOW_Y_POS, WINDOW_SIZE, WINDOW_SIZE, WM_CF_HIDE, _cbWin2, 0);

  while (1) {
    GUI_Delay(100);
  }
}

/*************************** End of file ****************************/